AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )
include( 'shared.lua' )

function ENT:SpawnFunction( ply, tr )
	if not ply:Alive() then return false end
	local ent = ents.Create( "rollerpilot" )
	ent:SetPos( ply:GetPos()+Vector(0,0,8) )
	ent:Spawn()
	ent:Activate()
	ent.Owner=ply
	
	ply:Spectate(5)
	ply:SpectateEntity(ent)
	ply:DrawViewModel(false)
	ply:DrawWorldModel(false)	
	ply:StripWeapons()
	ply.NoSpawning = true
	
	ent:CallOnRemove("UnSpectate",function() timer.Simple(3, function()
			if ply:IsValid() then
				ply:Spawn()
				ply.NoSpawning = nil
			end 
	end) end)
	ply:DeleteOnRemove(ent)
	return ent
end

function ENT:Initialize()
	self.Entity:SetModel("models/roller.mdl")
	self.Entity:PhysicsInit( SOLID_VPHYSICS )
	self.Entity:SetMoveType( MOVETYPE_VPHYSICS )
	self.Entity:SetSolid( SOLID_VPHYSICS )

	local phys = self.Entity:GetPhysicsObject()
	if (phys:IsValid()) then
		phys:Wake()
		phys:EnableDrag(true)
		phys:EnableMotion(true)
	end	
	self.NextZap = 0
	self.NextJump = 0
	self.NextBoost = 0
	
	self.Sparks = EffectData()
	self.Sparks:SetEntity(self.Entity)
	self.Sparks:SetMagnitude(3)
	self.Sparks:SetScale(2)
end

function ENT:Think()
	self.Owner:SetPos(self.Entity:GetPos())
	local look = self.Owner:GetAimVector()
	look.z = 0
	look:Normalize()
	
	
	local phys = self.Entity:GetPhysicsObject()
	local tr = util.QuickTrace( self.Entity:GetPos(), Vector(0,0,-40), self.Entity )
	local OnGround = tr.Hit
	
	
	if self.Owner:KeyDown(8) then --Forward
		phys:ApplyForceCenter(look*450)
	elseif self.Owner:KeyDown(16) then --Back
		phys:ApplyForceCenter(look*-450)
	end
	
	if self.Owner:KeyDown(512) then --Left
		look:Rotate(Angle(0,90,0))
		phys:ApplyForceCenter(look*450)
	elseif self.Owner:KeyDown(1024) then --Right
		look:Rotate(Angle(0,-90,0))
		phys:ApplyForceCenter(look*450)
	end
	
	if self.Owner:KeyDown(2) and self.NextJump<CurTime() and OnGround then --Jump
		phys:AddVelocity(Vector(0,0,350))
		self.NextJump = CurTime()+1
		local snd = "npc/roller/mine/rmine_taunt1.wav"
		if math.random(1,2)==2 then snd = "npc/roller/mine/rmine_blip1.wav" end
		self.Entity:EmitSound(snd,100,100)
	end
		
	if self.Sparking then
		self.Sparks:SetEntity(self.Entity)
		util.Effect("TeslaHitBoxes",self.Sparks)
	end
	
	if self.Owner:KeyDown(131072) and self.NextBoost<CurTime() then --Boost
		phys:AddVelocity(self.Owner:GetAimVector()*2500)
		self.NextBoost = CurTime()+2
		
		local Trail = ents.Create("env_spritetrail")
		Trail:SetPos(self.Entity:GetPos())
		Trail:SetParent(self.Entity)
		Trail:SetColor(self.Entity:GetColor())
		Trail:SetKeyValue("lifetime","10")
		Trail:SetKeyValue("startwidth","16")
		Trail:SetKeyValue("endwidth","5")
		Trail:SetKeyValue("spritename","trails/plasma.vmt")
		Trail:Spawn()
		Trail:Fire("Kill","",10)
		
		self.Entity:EmitSound("npc/roller/mine/rmine_blades_out"..math.random(1,3)..".wav",100,100)
		self.Entity:SetModel("models/roller_spikes.mdl")
		self.Sparking = true
		timer.Simple(2, function() if ValidEntity(Trail) then
			Trail:SetParent()
		end end)
	end
	
	if self.Owner:KeyDown(1) then
		if not self.Sparking then
			self.Sparking = true
			self.Entity:EmitSound("npc/roller/mine/rmine_blades_out"..math.random(1,3)..".wav",100,100)
			self.Entity:SetModel("models/roller_spikes.mdl")
		end
	elseif self.Sparking and self.NextBoost<CurTime() then
		self.Sparking = false
		self.Entity:SetModel("models/roller.mdl")
		self.Entity:EmitSound("npc/roller/mine/rmine_blades_in"..math.random(1,3)..".wav",100,100)	
	end
	
	if self.Entity:WaterLevel()==3 and not self.Dying then
		self.Dying = true
		self.Entity:EmitSound("npc/roller/mine/rmine_shockvehicle2.wav",100,100)
		timer.Simple(1,function() if self.Entity:IsValid() then
				local eff = EffectData()
				eff:SetOrigin(self.Entity:GetPos())
				util.Effect("Explosion", eff)
				self.Entity:Remove()
				umsg.Start( "PlayerKilledSelf" )
					umsg.Entity( self.Owner )
				umsg.End()
			end
		end)
	end
	if OnGround then
		phys:ApplyForceOffset(phys:GetVelocity()/3, self.Entity:GetPos()+Vector(0,0,50))
		phys:ApplyForceOffset(-phys:GetVelocity()/3, self.Entity:GetPos()-Vector(0,0,50))
	end
	self:NextThink(CurTime())
	return true
end
function ENT:PhysicsCollide( data, phys )
	local ent = data.HitEntity
	if self.Sparking and ValidEntity(ent) and self.NextZap<CurTime() and not ent:IsWorld() then
		self.NextZap = CurTime()+0.5
		self.Entity:EmitSound("npc/roller/mine/rmine_explode_shock1.wav",100,100)
		ent:TakeDamage(math.random(15,30), self.Owner, nil)
		
		phys:ApplyForceOffset((data.HitPos-self.Entity:GetPos())*-2000, data.HitPos)
		data.HitObject:ApplyForceOffset((data.HitPos-self.Entity:GetPos())*2000, data.HitPos)
		
		local eff = EffectData()
		eff:SetOrigin(data.HitPos)
		eff:SetMagnitude(3)
		eff:SetScale(1)
		util.Effect("cball_explode",eff)
	end
end

hook.Add("EntityTakeDamage","RollerPilot",function(vic,wep,att,amm,dmg)
	if att:GetClass()=="rollerpilot" then dmg:SetAttacker(att.Owner) end
end)
local function dontspawn(ply)
	if ply.NoSpawning then return false end
end
hook.Add("PlayerSpawnEffect","RollerPilot",dontspawn)
hook.Add("PlayerSpawnNPC","RollerPilot",dontspawn)
hook.Add("PlayerSpawnProp","RollerPilot",dontspawn)
hook.Add("PlayerSpawnRagdoll","RollerPilot",dontspawn)
hook.Add("PlayerSpawnSENT","RollerPilot",dontspawn)
hook.Add("PlayerSpawnSWEP","RollerPilot",dontspawn)
hook.Add("PlayerSpawnVehicle","RollerPilot",dontspawn)
hook.Add("CanPlayerSuicide","RollerPilot",dontspawn)